
#include <stdarg.h>
#include <string.h>

#if 1
#define logf(a...) do { } while (0)
#else
#define logf(a...) logger_logf(__FILE__, __LINE__, __FUNCTION__, a);
#endif

static inline void logger_logf (char *file, int line, const char *func, NSString *fmt, ...)
{
	va_list ap;
	NSString *s;
	NSString *t;
	const char *f;
	f = strrchr(file, '/');
	if (f == NULL) {
		f = file;
	} else {
		f++;
	}
	t = [NSString stringWithFormat:@" [%s (%s:%d)]", func, f, line];
	s = [fmt stringByAppendingString:t];
	va_start(ap, fmt);
	NSLogv(s, ap);
	va_end(ap);
	return;
err:
	assert(0);
}
