
#import "SnowForeCastAppDelegate.h"
#import "SwitchViewController.h"
#import "SnowViewController.h"
#import "Logger.h"
#import "resort.h"

@implementation SnowViewController

@synthesize timerObject;
@synthesize resortCondition;

@synthesize infoButton;
@synthesize pageControl;
@synthesize switchView;

@synthesize resortInfoLabel;
@synthesize resortStatusLabel;
@synthesize resortStatusAvtivity;
@synthesize reportScrollView;

@synthesize day0timeLabel, day0windLabel, day0snowLabel, day0rainLabel, day0tempLabel, day0windImage, day0summaryImage;
@synthesize day1timeLabel, day1windLabel, day1snowLabel, day1rainLabel, day1tempLabel, day1windImage, day1summaryImage;
@synthesize day2timeLabel, day2windLabel, day2snowLabel, day2rainLabel, day2tempLabel, day2windImage, day2summaryImage;
@synthesize day3timeLabel, day3windLabel, day3snowLabel, day3rainLabel, day3tempLabel, day3windImage, day3summaryImage;
@synthesize day4timeLabel, day4windLabel, day4snowLabel, day4rainLabel, day4tempLabel, day4windImage, day4summaryImage;
@synthesize day5timeLabel, day5windLabel, day5snowLabel, day5rainLabel, day5tempLabel, day5windImage, day5summaryImage;
@synthesize day6timeLabel, day6windLabel, day6snowLabel, day6rainLabel, day6tempLabel, day6windImage, day6summaryImage;
@synthesize day7timeLabel, day7windLabel, day7snowLabel, day7rainLabel, day7tempLabel, day7windImage, day7summaryImage;
@synthesize day8timeLabel, day8windLabel, day8snowLabel, day8rainLabel, day8tempLabel, day8windImage, day8summaryImage;
@synthesize day9timeLabel, day9windLabel, day9snowLabel, day9rainLabel, day9tempLabel, day9windImage, day9summaryImage;
@synthesize day10timeLabel, day10windLabel, day10snowLabel, day10rainLabel, day10tempLabel, day10windImage, day10summaryImage;
@synthesize day11timeLabel, day11windLabel, day11snowLabel, day11rainLabel, day11tempLabel, day11windImage, day11summaryImage;
@synthesize day12timeLabel, day12windLabel, day12snowLabel, day12rainLabel, day12tempLabel, day12windImage, day12summaryImage;
@synthesize day13timeLabel, day13windLabel, day13snowLabel, day13rainLabel, day13tempLabel, day13windImage, day13summaryImage;
@synthesize day14timeLabel, day14windLabel, day14snowLabel, day14rainLabel, day14tempLabel, day14windImage, day14summaryImage;
@synthesize day15timeLabel, day15windLabel, day15snowLabel, day15rainLabel, day15tempLabel, day15windImage, day15summaryImage;
@synthesize day16timeLabel, day16windLabel, day16snowLabel, day16rainLabel, day16tempLabel, day16windImage, day16summaryImage;
@synthesize day17timeLabel, day17windLabel, day17snowLabel, day17rainLabel, day17tempLabel, day17windImage, day17summaryImage;

- (void) viewDidLoad
{
	SnowForeCastAppDelegate *appDelegate;
	appDelegate = (SnowForeCastAppDelegate *) [[UIApplication sharedApplication] delegate];
	switchView = appDelegate.switchViewController;
	
	reportScrollView.contentSize = CGSizeMake(reportScrollView.frame.size.width, 672);
	reportScrollView.scrollsToTop = YES;

	[self updateUI];
	[super viewDidLoad];
}

- (void) didReceiveMemoryWarning
{
	[super didReceiveMemoryWarning];
}

- (void) viewDidUnload
{
}

- (void) dealloc {
	[super dealloc];
}

- (IBAction) switchPages:(id) sender
{
	NSInteger page;
	page = [[self pageControl] currentPage];
	logf(@"switching page:%d", page);
	if (timerObject != nil) {
		[timerObject invalidate];
		timerObject = nil;
	}
	resort_update_finish(resortCondition);
	resortCondition = NULL;
	[self updateUI];
}

- (IBAction) switchViews: (id) sender
{
	logf(@"swithing view");
	if (timerObject != nil) {
		[timerObject invalidate];
		timerObject = nil;
	}
	resort_update_finish(resortCondition);
	resortCondition = NULL;
	[switchView switchViews:sender];
}

- (void) timerMethod:(NSTimer *) timer
{
	int ret;
	logf(@"timer fired!");
	ret = resort_update_check(resortCondition);
	logf(@"resort_update_check() result:%d", ret);
	if (ret == 0) {
		resort_update_finish(resortCondition);
		resortCondition = NULL;
		[timerObject invalidate];
		timerObject = nil;
		
		resorts_free(switchView.resortsArray);
		switchView.resortsArray = resorts_read([switchView.databasePath UTF8String]);

		[resortStatusAvtivity stopAnimating];
		resortStatusLabel.text = @"Updated Resort Info!";

		[self updateView];
	} else if (ret == -2 || ret == -3) {
		resort_update_finish(resortCondition);
		resortCondition = NULL;
		[timerObject invalidate];
		timerObject = nil;

		[resortStatusAvtivity stopAnimating];
		resortStatusLabel.text = @"Could Not Update Resort Info!";
	}
}

- (void) updateSummaryImage:(UIImageView *) imageView summary:(const char *) summary time:(const char *) time
{
	static const struct summaryImage_s {
		char time;
		char *summary;
		char *image;
	} summaryImages[] = {
		{ 'M', "clear", "sunny.png" },
		{ 'A', "clear", "sunny.png" },
		{ 'N', "clear", "sunny_night.png" },
		{ 'M', "some clouds", "cloudy1.png" },
		{ 'A', "some clouds", "cloudy1.png" },
		{ 'N', "some clouds", "cloudy1_night.png" },
		{ 'M', "cloudy", "cloudy3.png" },
		{ 'A', "cloudy", "cloudy3.png" },
		{ 'N', "cloudy", "cloudy3_night.png" },
		{ 'M', "snow shwrs", "snow1.png" },
		{ 'A', "snow shwrs", "snow1.png" },
		{ 'N', "snow shwrs", "snow1_night.png" },
		{ 'M', "light snow", "snow3.png" },
		{ 'A', "light snow", "snow3.png" },
		{ 'N', "light snow", "snow3_night.png" },
		{ 'M', "mod. snow", "snow4.png" },
		{ 'A', "mod. snow", "snow4.png" },
		{ 'N', "mod. snow", "snow4.png" },
		{ 'M', "heavy snow", "snow5.png" },
		{ 'A', "heavy snow", "snow5.png" },
		{ 'N', "heavy snow", "snow5.png" },
		{ 'M', "rain shwrs", "shower1.png" },
		{ 'A', "rain shwrs", "shower1.png" },
		{ 'N', "rain shwrs", "shower1_night.png" },
		{ 'M', "light rain", "shower2.png" },
		{ 'A', "light rain", "shower2.png" },
		{ 'N', "light rain", "shower2_night.png" },
		{ 'M', "mod. rain", "shower3.png" },
		{ 'A', "mod. rain", "shower3.png" },
		{ 'N', "mod. rain", "shower3.png" },
		{ 'M', "heavy rain", "shower4.png" },
		{ 'A', "heavy rain", "shower4.png" },
		{ 'N', "heavy rain", "shower4.png" },
	};
	#define nSummaryImages (sizeof(summaryImages) / sizeof(summaryImages[0]))
	int i;
	NSString *l;
	l = @"dunno.png";
	logf(@"image for '%s':'%s'", summary, time);
	for (i = 0; i < nSummaryImages; i++) {
		if (summaryImages[i].time == time[4]) {
			if (strcasecmp(summaryImages[i].summary, summary) == 0) {
				l = [NSString stringWithUTF8String:summaryImages[i].image];
			}
		}
	}
	imageView.image = [UIImage imageNamed:l];
}

#define updateField(n) \
	day ## n ## timeLabel.text = [NSString stringWithUTF8String:resort->info.day[n].time]; \
	tmp = resort->info.day[n].wind; \
	while (tmp && *tmp) { \
		if (*tmp >= '0' && *tmp <= '9') { \
			break; \
		} \
		tmp++; \
	} \
	if (n == 0) { \
		day ## n ## windLabel.text = [NSString stringWithFormat:@"%s km/h", tmp]; \
	} else { \
		day ## n ## windLabel.text = [NSString stringWithUTF8String:tmp]; \
	} \
	day ## n ## snowLabel.text = [NSString stringWithUTF8String:resort->info.day[n].snow]; \
	day ## n ## rainLabel.text = [NSString stringWithUTF8String:resort->info.day[n].rain]; \
	day ## n ## tempLabel.text = [NSString stringWithFormat:@"%s° / %s°", resort->info.day[n].mintemp, resort->info.day[n].maxtemp]; \
	[self updateSummaryImage:day ## n ## summaryImage summary:resort->info.day[n].summary time:resort->info.day[n].time];

- (void) updateView
{
	char *tmp;
	NSInteger count;
	resort_t *resort;
	
	logf(@"updating view");
	
	count = resorts_count(switchView.resortsArray);
	pageControl.numberOfPages = count;
	resort = resorts_resort(switchView.resortsArray, [pageControl currentPage]);
	if (resort == NULL) {
		logf(@"impossible happened (resort == NULL)");
		assert(0);
	}
	
	resortInfoLabel.text = [NSString stringWithFormat:@"%s at %s m.", resort->link, resort->info.altitude];
	
	updateField(0);
	updateField(1);
	updateField(2);
	updateField(3);
	updateField(4);
	updateField(5);
	updateField(6);
	updateField(7);
	updateField(8);
	updateField(9);
	updateField(10);
	updateField(11);
	updateField(12);
	updateField(13);
	updateField(14);
	updateField(15);
	updateField(16);
	updateField(17);
}

- (void) updateUI
{
	NSInteger count;
	resort_t *resort;
	
	logf(@"updating ui");
	
	[self updateView];
	
	count = resorts_count(switchView.resortsArray);
	pageControl.numberOfPages = count;
	resort = resorts_resort(switchView.resortsArray, [pageControl currentPage]);
	if (resort == NULL) {
		logf(@"impossible happened (resort == NULL)");
		assert(0);
	}

	logf(@"updating resort:%s @ %d", resort->name, resort->level);
	resortCondition = resort_update_start([switchView.databasePath UTF8String], resort);
	if (resort_update_check(resortCondition) == 0) {
		resort_update_finish(resortCondition);
		resortCondition = NULL;
		[resortStatusAvtivity stopAnimating];
		resortStatusLabel.text = @"Updated Resort Info!";
	} else {
		timerObject = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(timerMethod:) userInfo:self repeats:YES];
		[resortStatusAvtivity startAnimating];
		resortStatusLabel.text = @"Updating Resort Info...";
	}
	CGRect frame = reportScrollView.frame;
	frame.origin.x = 0;
	frame.origin.y = 0;
	[reportScrollView scrollRectToVisible:frame animated:NO];
	reportScrollView.indicatorStyle = UIScrollViewIndicatorStyleWhite;
}

@end
